'use strict';

const config = require('./../../config');
const logger = require('./../../utils/logger');
const errors = require('./../../utils/dz-errors-api');
const dbConstants = require('./../../constants/db-constants');
const query = require('./../../utils/query-creator-api');
const CMS = require('./../../models/cms');
const moment = require('moment');
let async = require('async');
let _ = require('underscore');

/*
	Name : List
	Purpose : List
	Original Author : Gaurav Patel
	Created At : 5th Mar 2021
*/
const list = async(requestParam) => {
    return new Promise(async(resolve, reject) => {
        try {
            let cms = await query.selectWithAnd(dbConstants.dbSchema.cms, { type: requestParam.type }, { _id: 0, cms_id: 1, title: 1, code:1, link: 1, type:1, description:1 }, { created_at: 1 });
            cms = JSON.parse(JSON.stringify(cms));
            _.each(cms, (element, index, list) => {
                let link = config.cms.link_path + element.link[requestParam.code]
                if(element.code === 'PRIVACY_POLICY'){
                    link = 'https://www.parksie.com/privacy-policy.html';
                } else if(element.code === 'TERM_CONDITION'){
                    link = 'https://www.parksie.com/parksie-terms-and-conditions.html';
                }
                element['title'] = element.title[requestParam.code] || '';
                element['description'] = element.description[requestParam.code] || '';
                element['link'] = link;
            });

            resolve(cms)
            return;
        } catch (error) {
            reject(error)
            return
        }
    })
};

module.exports = {
    list
};