'use strict';

const config = require('./../../config');
const logger = require('./../../utils/logger');
const errors = require('./../../utils/dz-errors-api');
const dbConstants = require('./../../constants/db-constants');
const query = require('./../../utils/query-creator-api');
let moment = require('moment');
let async = require('async');
let _ = require('underscore');
let LD = require('lodash');

/*
    Name : Cron Run for payput
    Purpose : Cron Run for payput
    Original Author : Gaurav Patel
    Created At : 15th Nov 2021
*/
const payout = async (requestParam) => {
    return new Promise(async (resolve, reject) => {
        try {
            // let settings = await query.selectWithAndOne(dbConstants.dbSchema.settings, {}, {_id: 0,is_payment_live: 1});
            // let stripe = require("stripe")(settings.is_payment_live ? config.stripeInfo.live_key : config.stripeInfo.test_key);

            // let amount = (10 * 100);
            // const source = await stripe.sources.create({
            //     type: 'ach_credit_transfer',
            //     currency: 'usd',
            //     owner: {email: 'jaimin.rami@xongolab.com'},
            // });
            // console.log(source)
            // const customer = await stripe.customers.create({
            //     email: 'jaimin.rami@xongolab.com',
            //     source: source.id,
            // });
            // // console.log(customer)
            // const charge = await stripe.charges.create({
            //     amount: amount,
            //     currency: 'usd',
            //     customer: customer.id,
            //     source: source.id,
            // });
            // console.log(charge)
            // return false;
            let columnAndVal = {}
            if (requestParam.type == 'monthly') {
                columnAndVal['title.EN'] = 'Monthly'
            }
            if (requestParam.type == 'quarterly') {
                columnAndVal['title.EN'] = 'Quarterly'
            }
            if (requestParam.type == 'annually') {
                columnAndVal['title.EN'] = 'Annually'
            }
            console.log(requestParam);
            let payment_frequency = await query.selectWithAndOne(dbConstants.dbSchema.payment_frequencies, columnAndVal, { _id: 0, payment_frequency_id: 1 }, { created_at: -1 });
            // console.log(payment_frequency);
            if (payment_frequency) {

                // modified owners find query
                let columnAndValues = { status: 'active', stripe_connected_account_id: { $ne: "" }, 'bank_details.payment_frequency_id': payment_frequency.payment_frequency_id, bank_details_added: true }
                // FOR MANUALLY PAYOUT
                if (requestParam.owner_id) {
                    columnAndValues.customer_id = requestParam.owner_id
                }
                // FOR MANUALLY PAYOUT
                let owners = await query.selectWithAnd(dbConstants.dbSchema.customers, columnAndValues, { _id: 0, user_type: 1, customer_id: 1, name: 1, bank_details_added: 1, bank_details: 1, stripe_connected_account_id: 1, stripe_customer_account_id: 1 }, { created_at: -1 });
                console.log(owners);

                let settings = await query.selectWithAndOne(dbConstants.dbSchema.settings, {}, { _id: 0, is_payment_live: 1 });
                let stripe = require("stripe")(settings.is_payment_live ? config.stripeInfo.live_key : config.stripeInfo.test_key);

                await Promise.all(owners.map(async (elem) => {

                    /**
                     * New payout functionality stated from here
                     */
                    const balance = await stripe.balance.retrieve({
                        stripeAccount: elem.stripe_connected_account_id,
                    });

                    let payoutAmount = balance.available[0].amount;
                    console.log(elem.stripe_connected_account_id, payoutAmount, balance)
                    if (payoutAmount > 0) {
                        let payouts = await stripe.payouts.create({
                            amount: payoutAmount,
                            currency: 'usd',
                            description: "Transferred $ " + parseFloat(payoutAmount) + " Into " + elem.name + " Bank Account",
                        }, {
                            stripeAccount: elem.stripe_connected_account_id,
                        });

                        if (payouts) {
                            let nextDate = ''
                            if (requestParam.type == 'monthly') {
                                var d = new Date();
                                d.setMonth(d.getMonth() + 1, 1);
                                nextDate = new Date(d)
                            }
                            if (requestParam.type == 'annually') {
                                var d = new Date();
                                let yr = d.getFullYear()
                                yr = parseFloat(yr)
                                nextDate = new Date(yr + 1, 0, 1)
                            }
                            if (requestParam.type == 'quarterly') {
                                var today = new Date();
                                var quarter = Math.floor((today.getMonth() + 3) / 3);
                                if (quarter == 4) {
                                    nextDate = new Date(today.getFullYear() + 1, 0, 1);
                                } else {
                                    nextDate = new Date(today.getFullYear(), quarter * 3, 1);
                                }
                            }

                            let obj = {
                                transaction_id: payouts.id,
                                owner_id: elem.customer_id,
                                owner_details: {
                                    name: elem.name,
                                    user_type: elem.user_type
                                },
                                bank_details: elem.bank_details,
                                last_payment_date: new Date(),
                                last_payout_total: total,
                                next_payment_date: nextDate,
                                status: 'success',
                                type: requestParam.type
                            }
                            await query.insertSingle(dbConstants.dbSchema.payouts, obj);
                            await query.updateMultiple(dbConstants.dbSchema.reservations, { is_owner_paid: true }, { 'reservation_id': { $in: _.pluck(reservations, 'reservation_id') } });
                        }
                    }
                    /** New payout functionality ended to here */

                    /**
                     * Old payout functionality stated from here
                     */

                    // let reservations = await query.selectWithAnd(dbConstants.dbSchema.reservations, { status: 'completed', owner_id: elem.customer_id, is_owner_paid: false }, { _id: 0, owner_id: 1, reservation_id: 1, owner_earn: 1 }, { created_at: -1 });
                    // let amount = Math.round(total * 100);
                    // console.log(elem)
                    // console.log(amount)
                    // console.log(elem.stripe_connected_account_id)
                    //let transfer = null
                    // let transfer = await stripe.transfers.create({
                    //     amount,
                    //     currency: 'usd',
                    //     destination: elem.stripe_connected_account_id,
                    //     transfer_group: "Transferred $ " + parseFloat(total) + " Into " + elem.name + " Bank Account",
                    // });
                    // if (reservations.length > 0) {
                    //     let total = parseFloat(LD.sumBy(reservations, 'owner_earn')).toFixed(2)
                    //     total = parseFloat(total)

                    //     let settings = await query.selectWithAndOne(dbConstants.dbSchema.settings, {}, { _id: 0, is_payment_live: 1 });
                    //     let stripe = require("stripe")(settings.is_payment_live ? config.stripeInfo.live_key : config.stripeInfo.test_key);

                    //     let amount = Math.round(total * 100);
                    //     // console.log(elem)
                    //     // console.log(amount)
                    //     // console.log(elem.stripe_connected_account_id)
                    //     //let transfer = null
                    //     // let transfer = await stripe.transfers.create({
                    //     //     amount,
                    //     //     currency: 'usd',
                    //     //     destination: elem.stripe_connected_account_id,
                    //     //     transfer_group: "Transferred $ " + parseFloat(total) + " Into " + elem.name + " Bank Account",
                    //     // });

                    //     const balance = await stripe.balance.retrieve({
                    //         stripeAccount: 'acct_1MUkzcPRxXxzW9xv',
                    //     });

                    //     console.log("balance amount --> ", balance)

                    //     let transfer = await stripe.payouts.create({
                    //         amount: balance.available[0].amount,
                    //         currency: 'usd',
                    //         // destination: elem.stripe_customer_account_id,
                    //         description: "Transferred $ " + parseFloat(total) + " Into " + elem.name + " Bank Account",
                    //     }, {
                    //         stripeAccount: elem.stripe_connected_account_id,
                    //     });

                    //     // const transfer = await stripe.charges.create({
                    //     //     amount,
                    //     //     currency: 'usd',
                    //     //     customer: elem.stripe_connected_account_id,
                    //     //     source: elem.stripe_customer_account_id,
                    //     //   });
                    //     console.log("transfer", transfer);

                    //     let nextDate = ''
                    //     if (requestParam.type == 'monthly') {
                    //         var d = new Date();
                    //         d.setMonth(d.getMonth() + 1, 1);
                    //         nextDate = new Date(d)
                    //     }
                    //     if (requestParam.type == 'annually') {
                    //         var d = new Date();
                    //         let yr = d.getFullYear()
                    //         yr = parseFloat(yr)
                    //         nextDate = new Date(yr + 1, 0, 1)
                    //     }
                    //     if (requestParam.type == 'quarterly') {
                    //         var today = new Date();
                    //         var quarter = Math.floor((today.getMonth() + 3) / 3);
                    //         if (quarter == 4) {
                    //             nextDate = new Date(today.getFullYear() + 1, 0, 1);
                    //         } else {
                    //             nextDate = new Date(today.getFullYear(), quarter * 3, 1);
                    //         }
                    //     }

                    //     let obj = {
                    //         transaction_id: transfer ? transfer.id : '',
                    //         owner_id: elem.customer_id,
                    //         owner_details: {
                    //             name: elem.name,
                    //             user_type: elem.user_type
                    //         },
                    //         bank_details: elem.bank_details,
                    //         last_payment_date: new Date(),
                    //         last_payout_total: total,
                    //         next_payment_date: nextDate,
                    //         status: 'success',
                    //         type: requestParam.type
                    //     }
                    //     await query.insertSingle(dbConstants.dbSchema.payouts, obj);
                    //     await query.updateMultiple(dbConstants.dbSchema.reservations, { is_owner_paid: true }, { 'reservation_id': { $in: _.pluck(reservations, 'reservation_id') } });
                    // }

                    /**
                    * Old payout functionality ended to here
                    */
                }))
            }
            resolve({})
            return;
        } catch (error) {
            console.log(error)
            reject(error)
            return
        }
    })
};

module.exports = {
    payout
};