'use strict';

const config = require('./../../config');
const logger = require('./../../utils/logger');
const errors = require('./../../utils/dz-errors-api');
const dbConstants = require('./../../constants/db-constants');
const query = require('./../../utils/query-creator-api');
let async = require('async');
let _ = require('underscore');

/*
	Name : List
	Purpose : List
	Original Author : Gaurav Patel
    Created At : 5th Mar 2021
*/
const list = async(requestParam) => {
    return new Promise(async(resolve, reject) => {
        try {
            let data = await query.selectWithAnd(dbConstants.dbSchema.measurements, { status: 'active'}, { _id: 0, measurement_id: 1, title: 1, unit:1 }, { created_at: 1 });
            data = JSON.parse(JSON.stringify(data));
            _.each(data, (element, index, list) => {
                data[index]['title'] = element.title[requestParam.code] || '';
            });

            resolve(data)
            return;
        } catch (error) {
            reject(error)
            return
        }
    })
};

module.exports = {
    list
};