// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var bankAccountTypeSchema = new Schema({
    bank_account_type_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
bankAccountTypeSchema.pre('save', function(callback) {
    idGenerator.generateId('banks', 'bank_account_type_id', 'BAT', (err, ID) => {
        this.bank_account_type_id = ID;
        callback();
    });
});

var Bank_account_type = mongoose.model('Bank_account_type', bankAccountTypeSchema);
module.exports = Bank_account_type;