// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var ownerRatingSchema = new Schema({
    rating_id: {
        type: String,
        default:''
    },
    owner_id: {
        type: String,
        default:''
    },
    customer_id: {
        type: String,
        default:''
    },
    reservation_id: {
        type: String,
        default:''
    },
    rating: {
        type: Number,
        default:0
    },
    rating_status: {
        type: String,
        default:''
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
ownerRatingSchema.pre('save', function(callback) {
    idGenerator.generateId('owner_ratings', 'rating_id', 'OWR', (err, ID) => {
        this.rating_id = ID;
        callback();
    });
});

var Owner_rating = mongoose.model('Owner_rating', ownerRatingSchema);
module.exports = Owner_rating;