// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var parkingSpotTypeSchema = new Schema({
    parking_spot_type_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    order_no: {
        type: Number,
        default:0
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
parkingSpotTypeSchema.pre('save', function(callback) {
    idGenerator.generateId('parking_spot_types', 'parking_spot_type_id', 'PST', (err, ID) => {
        this.parking_spot_type_id = ID;
        callback();
    });
});

var Parking_spot_type = mongoose.model('Parking_spot_type', parkingSpotTypeSchema);
module.exports = Parking_spot_type;