// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var payoutSchema = new Schema({
    payout_id: {
        type: String,
        default:''
    },
    transaction_id: {
        type: String,
        default:''
    },
    owner_id: {
        type: String,
        default:''
    },
    owner_details: {
        type: Object,
        default: {}
    },
    bank_details:{
        type: Object,
        default:{}
    },
    last_payment_date: {
        type: Date,
        default: Date.now
    },
    last_payout_total: {
        type: Number,
        default: 0
    },
    next_payment_date: {
        type: Date,
        default: Date.now
    },
    type: {
        type: String,
        default:''
    },
    status: {
        type: String,
        enum: ['success', 'failure'],
        default:'success'
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
payoutSchema.pre('save', function(callback) {
    idGenerator.generateId('payouts', 'payout_id', 'PAY', (err, ID) => {
        this.payout_id = ID;
        callback();
    });
});

var Payout = mongoose.model('Payout', payoutSchema);
module.exports = Payout;