// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var pricingSchema = new Schema({
    pricing_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    code: {
        type: String,
        default:''
    },
    suggested_price: {
        type: Number,
        default:0
    },
    min_price: {
        type: Number,
        default:0
    },
    max_price: {
        type: Number,
        default:0
    },
    status: {
        type: String,
        enum: ["active", "inactive"],
        default:"active"
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
pricingSchema.pre('save', function(callback) {
    idGenerator.generateId('pricings', 'pricing_id', 'PRI', (err, ID) => {
        this.pricing_id = ID;
        callback();
    });
});

var Pricing = mongoose.model('Pricing', pricingSchema);
module.exports = Pricing;