// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var propertyRatingSchema = new Schema({
    property_rating_id: {
        type: String,
        default:''
    },
    property_id: {
        type: String,
        default:''
    },
    reservation_id: {
        type: String,
        default:''
    },
    customer_id: {
        type: String,
        default:''
    },
    rating: {
        type: Number,
        default:0
    },
    rating_status: {
        type: String,
        default:''
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
propertyRatingSchema.pre('save', function(callback) {
    idGenerator.generateId('property_ratings', 'property_rating_id', 'PRR', (err, ID) => {
        this.property_rating_id = ID;
        callback();
    });
});

var Property_rating = mongoose.model('Property_rating', propertyRatingSchema);
module.exports = Property_rating;