// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var seekerRatingSchema = new Schema({
    rating_id: {
        type: String,
        default:''
    },
    seeker_id: {
        type: String,
        default:''
    },
    reservation_id: {
        type: String,
        default:''
    },
    customer_id: {
        type: String,
        default:''
    },
    rating: {
        type: Number,
        default:0
    },
    rating_status: {
        type: String,
        default:''
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
seekerRatingSchema.pre('save', function(callback) {
    idGenerator.generateId('seeker_ratings', 'rating_id', 'SER', (err, ID) => {
        this.rating_id = ID;
        callback();
    });
});

var Seeker_rating = mongoose.model('Seeker_rating', seekerRatingSchema);
module.exports = Seeker_rating;