// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var taxSchema = new Schema({
    tax_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    percentage: {
        type: Number,
        default:0
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
taxSchema.pre('save', function(callback) {
    idGenerator.generateId('taxes', 'tax_id', 'TAX', (err, ID) => {
        this.tax_id = ID;
        callback();
    });
});

var Tax = mongoose.model('Tax', taxSchema);
module.exports = Tax;