// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var vehicleColorSchema = new Schema({
    vehicle_color_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    color_code: {
        type: String,
        default:''
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
vehicleColorSchema.pre('save', function(callback) {
    idGenerator.generateId('vehicle_colors', 'vehicle_color_id', 'VHC', (err, ID) => {
        this.vehicle_color_id = ID;
        callback();
    });
});

var Vehicle_color = mongoose.model('Vehicle_color', vehicleColorSchema);
module.exports = Vehicle_color;