import { Dep, Lockfile, LockfileType } from './index';
import { DepMap, LockParserBase } from './lock-parser-base';
export interface PackageLock {
    name: string;
    version: string;
    dependencies?: PackageLockDeps;
    lockfileVersion: number;
    type: LockfileType.npm;
}
export interface PackageLockDeps {
    [depName: string]: PackageLockDep;
}
export interface PackageLockDep {
    version: string;
    requires?: {
        [depName: string]: string;
    };
    dependencies?: PackageLockDeps;
    dev?: boolean;
}
export declare class PackageLockParser extends LockParserBase {
    constructor();
    parseLockFile(lockFileContents: string): PackageLock;
    protected getDepMap(lockfile: Lockfile): DepMap;
    protected getDepTreeKey(dep: Dep): string;
}
