'use strict';

const responseCodes =  require('./../../helpers/response-codes');
const logger = require('./../../utils/logger');
const jsonResponse = require('./../../utils/json-response');
const errors = require('./../../utils/dz-errors');
const express = require('express');
const router = express.Router();
const _ = require('underscore');
const payoutHandler = require('./../../model_handlers/backend/payouts-handler');

router.get('/get',function (req, res) {
	payoutHandler.get(req,function (error, languages) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), languages);
	});
});

router.get('/get-history',function (req, res) {
	payoutHandler.getHistory(req,function (error, languages) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), languages);
	});
});

router.post('/manually',function (req, res) {
	payoutHandler.manually(req.body,function (error, languages) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), languages);
	});
});


module.exports = router;